$   ver = 'F$VERIFY(0)
$   GOTO TREESIZE
$!
$!  PROCEDURE TREESIZE
$!
$!  Computes the number of blocks in the directory structure given
$!  as the argument.  The structure is assumed to be a DECUS dir-
$!  ectory structure on DRA5.
$!
$!  To save time, we do not always need to count the blocks; this
$!  procedure saves the count in a file, and if the same structure
$!  is called for again in a subsequent call, it simply reads the
$!  count from the file; this is not done for [VAX000] and its com-
$!  ponents, since its size can change.  For example, the size of
$!  [VAX82B...] is saved in the file 'VAX82B.SIZ'.
$!
$!  The output of this procedure is the symbol BLOCKS.
$!
$ TREESIZE:
$   ON CONTROL_Y THEN  GOTO CLEANUP
$   ON ERROR     THEN  GOTO CLEANUP
$!
$   WRITE SYS$OUTPUT "
Computing number of blocks in ''p1'"
$!
$   name = ""
$!
$   IF F$LOCATE("[VAX000",p1) .EQS. 0 THEN  GOTO COUNT
$!
$   name = F$EXTRACT(1,6,p1) + ".SIZ"
$   IF F$SEARCH(name) .EQS. "" THEN  GOTO COUNT
$!
$   OPEN  TTEMP 'name'
$   READ  TTEMP blocks
$   CLOSE TTEMP
$!
$   blocks == blocks
$   DELETE /SYMBOL /LOCAL blocks
$   GOTO EXIT
$   
$ COUNT:
$   IF name .NES. "" THEN -
	WRITE SYS$OUTPUT "
		This is going to take a while..."
$!
$   DIR /SIZE /TOTAL /OUTPUT=TTEMP.TMP 'VAXSIG$DISK':'p1'
$!
$   OPEN TTEMP TTEMP.TMP
$!
$ LOOP:
$   READ /END=END TTEMP line
$   GOTO LOOP
$!
$ END:
$   CLOSE TTEMP
$   DELETE TTEMP.TMP;*
$!
$   col = F$LOCATE("files,",line)+7
$   len = F$LOCATE(" blocks",line)-col
$   blocks == F$EXTRACT(col,len,line)
$!
$   IF name .EQS. "" THEN  GOTO EXIT
$!
$   OPEN /WRITE TTEMP 'name'
$   WRITE TTEMP blocks
$   CLOSE TTEMP
$!
$ EXIT:
$   WRITE SYS$OUTPUT "
''p1' Contains ''blocks' Blocks.
"
$!
$ PAD:
$   IF F$LENGTH(blocks) .GE. 6 THEN  GOTO DONE
$   blocks == " " + blocks
$   GOTO PAD
$!
$ CLEANUP:
$   SET NOON
$   IF F$LOGICAL("TTEMP")    .NES. "" THEN  CLOSE  TTEMP
$   IF F$SEARCH("TTEMP.TMP") .NES. "" THEN  DELETE TTEMP.TMP;*
$!
$ DONE:
$   IF ver THEN  SET VERIFY
